from rest_framework import serializers
from reqman.apps.reqtool.models.suffix_req import Suffix, Suffix_S1, Suffix_S2, Suffix_S3, Suffix_S4, Suffix_S5, Suffix_S6


class SuffixSerializer(serializers.ModelSerializer):
    boilerplate_of_suffix = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix
        fields = ( 'id', 'boilerplate_of_suffix', 'suffix_owner', 'suffix_choices')


class Suffix_S1Serializer(serializers.ModelSerializer):
    boilerplate_of_s1 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s1 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S1
        fields = ( 'id', 'boilerplate_of_s1', 'suffix_owner_of_s1', 'numerical_affirmative_s1', 'numerical_s1', 'mumerical_units_s1', 'time_units_s1')


class Suffix_S2Serializer(serializers.ModelSerializer):
    boilerplate_of_s2 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s2 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S2
        fields = ( 'id', 'boilerplate_of_s2', 'suffix_owner_of_s2', 's2_s2', 'flow_s2')


class Suffix_S3Serializer(serializers.ModelSerializer):
    boilerplate_of_s3 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s3 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S3
        fields = ( 'id', 'boilerplate_of_s3', 'suffix_owner_of_s3', 's3_s3', 'numerical_s3', 'time_units_s3', 'flow_s3')


class Suffix_S4Serializer(serializers.ModelSerializer):
    boilerplate_of_s4 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s4 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S4
        fields = ( 'id', 'boilerplate_of_s4', 'suffix_owner_of_s4', 's4_s4')


class Suffix_S5Serializer(serializers.ModelSerializer):
    boilerplate_of_s5 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s5 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S5
        fields = ( 'id', 'boilerplate_of_s5', 'suffix_owner_of_s5', 's5_s5')


class Suffix_S6Serializer(serializers.ModelSerializer):
    boilerplate_of_s6 = serializers.PrimaryKeyRelatedField(read_only=True)
    suffix_owner_of_s6 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Suffix_S6
        fields = ( 'id', 'boilerplate_of_s6', 'suffix_owner_of_s6', 's6_s6')

