from rest_framework.generics import ListAPIView, RetrieveUpdateDestroyAPIView, ListAPIView
from rest_framework import permissions

from django.http import HttpResponse, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from rest_framework.parsers import JSONParser

from reqman.apps.reqtool.models.main_req import Main, Main_M1, Main_M2, Main_M3, Main_M4
from reqman.apps.reqtool.models.main_req import Main_M5, Main_M6, Main_M7, Main_M8
from reqman.apps.reqtool.models.main_req import Main_M9, Main_M10, Main_M11, Main_M12
from reqman.apps.reqtool.models.main_req import Main_M13, Main_M14, Main_M15, Main_M16

from reqman.apps.reqtool.rest_api.serializers.main_req import MainSerializer, Main_M1Serializer, Main_M2Serializer, Main_M3Serializer, Main_M4Serializer
from reqman.apps.reqtool.rest_api.serializers.main_req import Main_M5Serializer, Main_M6Serializer, Main_M7Serializer, Main_M8Serializer
from reqman.apps.reqtool.rest_api.serializers.main_req import Main_M9Serializer, Main_M10Serializer, Main_M11Serializer, Main_M12Serializer
from reqman.apps.reqtool.rest_api.serializers.main_req import Main_M13Serializer, Main_M14Serializer, Main_M15Serializer, Main_M16Serializer

from reqman.apps.permissions import IsOwnerOrReadOnly
from reqman.apps.reqtool.rest_api.services import fuseki

class MainListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = MainSerializer
    #
    queryset = Main.objects.all()

    def get_queryset(self):
        group_pk = self.kwargs['boilerplate']
        #print(group_pk)
        queryset_main = Main.objects.filter(boilerplate_of_main = group_pk)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class MainDetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]

    serializer_class = MainSerializer
    
    def get_queryset(self):
        group_pk = self.kwargs['boilerplate']
        #print(group_pk)
        queryset_main= Main.objects.filter(boilerplate_of_main = group_pk)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M1ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M1Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M1.objects.filter(boilerplate_of_m1 = bp, main_owner_of_m1 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M1DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M1Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M1.objects.filter(boilerplate_of_m1 = bp, main_owner_of_m1 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M2ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M2Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M2.objects.filter(boilerplate_of_m2 = bp, main_owner_of_m2 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M2DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M2Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M2.objects.filter(boilerplate_of_m2 = bp, main_owner_of_m2 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M3ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M3Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M3.objects.filter(boilerplate_of_m3 = bp, main_owner_of_m3 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M3DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M3Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M3.objects.filter(boilerplate_of_m3 = bp, main_owner_of_m3 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M4ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M4Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M4.objects.filter(boilerplate_of_m4 = bp, main_owner_of_m4 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M4DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M4Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M4.objects.filter(boilerplate_of_m4 = bp, main_owner_of_m4 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M5ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M5Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M5.objects.filter(boilerplate_of_m5 = bp, main_owner_of_m5 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M5DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M5Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M5.objects.filter(boilerplate_of_m5 = bp, main_owner_of_m5 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M6ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M6Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M6.objects.filter(boilerplate_of_m6 = bp, main_owner_of_m6 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M6DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M6Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M6.objects.filter(boilerplate_of_m6 = bp, main_owner_of_m6 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M7ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M7Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M7.objects.filter(boilerplate_of_m7 = bp, main_owner_of_m7 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M7DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M7Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M7.objects.filter(boilerplate_of_m7 = bp, main_owner_of_m7 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M8ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M8Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M8.objects.filter(boilerplate_of_m8 = bp, main_owner_of_m8 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M8DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M8Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M8.objects.filter(boilerplate_of_m8 = bp, main_owner_of_m8 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M9ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M9Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M9.objects.filter(boilerplate_of_m9 = bp, main_owner_of_m9 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M9DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M9Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M9.objects.filter(boilerplate_of_m9 = bp, main_owner_of_m9 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M10ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M10Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M10.objects.filter(boilerplate_of_m10 = bp, main_owner_of_m10 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M10DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M10Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M10.objects.filter(boilerplate_of_m10 = bp, main_owner_of_m10 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M11ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M11Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M11.objects.filter(boilerplate_of_m11 = bp, main_owner_of_m11 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M11DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M11Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M11.objects.filter(boilerplate_of_m11 = bp, main_owner_of_m11 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M12ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M12Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M12.objects.filter(boilerplate_of_m12 = bp, main_owner_of_m12 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M12DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M12Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M12.objects.filter(boilerplate_of_m12 = bp, main_owner_of_m12 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M13ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M13Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M13.objects.filter(boilerplate_of_m13 = bp, main_owner_of_m13 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M13DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M13Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M13.objects.filter(boilerplate_of_m13 = bp, main_owner_of_m13 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M14ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M14Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M14.objects.filter(boilerplate_of_m14 = bp, main_owner_of_m14 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M14DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M14Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M14.objects.filter(boilerplate_of_m14 = bp, main_owner_of_m14 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M15ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M15Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M15.objects.filter(boilerplate_of_m15 = bp, main_owner_of_m15 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M15DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M15Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M15.objects.filter(boilerplate_of_m15 = bp, main_owner_of_m15 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


class Main_M16ListAPIView(ListAPIView):
    """
    API view to retrieve list of posts or create new
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M16Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M16.objects.filter(boilerplate_of_m16 = bp, main_owner_of_m16 = mn)
        return queryset_main

    #Custom actions when POST
    def perform_create(self, serializer):
        serializer.save()
        #print the data of the post
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

class Main_M16DetailsAPIView(RetrieveUpdateDestroyAPIView):
    """
    API view to retrieve, update or delete post
    """
    permission_classes = [permissions.IsAuthenticatedOrReadOnly]
    serializer_class = Main_M16Serializer

    def get_queryset(self):
        bp = self.kwargs['boilerplate']
        mn = self.kwargs['mains']
        #print(group_pk)
        queryset_main = Main_M16.objects.filter(boilerplate_of_m16 = bp, main_owner_of_m16 = mn)
        return queryset_main

    #Custom actions when PUT
    def perform_update(self, serializer):
        serializer.save()
        #print(self.new.changed_data)
        #instance = serializer.save()
        #write_fuseki = fuseki.FusekiActions()
        #write_fuseki.write(serializer.data)

    #Custom actions when DELETE
    def perform_destroy(self, instance):
        #print("deleted")
        instance.delete()


